<?php

require __DIR__ . "/../vendor/autoload.php";
require __DIR__ . "/../vendor/zeedhi/framework/bootstrap.php";
require __DIR__ . "/../vendor/teknisa/libraries-next/scripts/bootstrap.php";
$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

/**
 * Caminhos dos XML do produto
 */
$db = __DIR__.'/../../../../backend/config/db.xml';
$parameters = __DIR__.'/../../../../backend/config/parameters.xml';
$general = __DIR__.'/../../../../backend/config/general.xml';

if (!realpath($db))  {
    $db = __DIR__ . "/../config/db.xml";
}

/**
 * Carregando XML do produto
 */
$instanceManager->loadFromFile($parameters);
$instanceManager->loadFromFile($general);
$instanceManager->loadFromFile($db);

$instanceManager->loadFromFile(__DIR__ . '/../config/environment.xml');
$instanceManager->loadFromFile(__DIR__ . '/../config/configParams.xml');
$instanceManager->loadFromFile(__DIR__ . '/../config/parameters.xml');
$instanceManager->loadFromFile(__DIR__ . '/../config/di_maps/dependencies.xml');
$instanceManager->loadFromFile(__DIR__ . '/../config/di_maps/repositories.xml');
$instanceManager->loadFromFile(__DIR__ . '/../config/di_maps/services.xml');
$instanceManager->loadFromFile(__DIR__ . '/../config/di_maps/controllers.xml');

$routes = array();
$routes[] = __DIR__ . '/../vendor/teknisa/libraries-next/libRoutes.json';
$routes[] = __DIR__ . '/../config/routes.json';

/**
 * zhuacl
 */
$acl = __DIR__.'/../config/acl.xml';
if(realpath($acl)){
    $instanceManager->loadFromFile($acl);
}
require __DIR__ . "/../vendor/zeedhi/zhuaclbackend/service/bootstrap.php";
$routes[] = __DIR__."/../vendor/zeedhi/zhuaclbackend/config/routes.json";

$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));
$instanceManager->compile();

///** @var \Doctrine\ORM\EntityManager $entity_manager */
//$entity_manager = $instanceManager->getService('entityManager');
//\Setforms2\Shared\Registry::store("EntityManager", $entity_manager);
//\Setforms2\Shared\Registry::store("EntityManagerConnection", $entity_manager->getConnection());
