<?php

namespace ACL\Controllers;

use ACL\Traits\TResponse;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use ACL\Services\Perfacessparc as PerfacessparcService;

class Perfacessparc {

    use TResponse;

    /**
     * @var PerfacessparcService
     */
    private $perfacessparcService;

    public function __construct(PerfacessparcService $perfacessparcService)
    {
        $this->perfacessparcService = $perfacessparcService;
    }

    public function savePerfaccessparc(Request $request, Response $response)
    {
        try{
            $rows = $request->getParameters();
            $data = $this->perfacessparcService->savePerfaccessparc($rows);
            $this->sendResponse($data, 200);
        }catch(\Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deletePerfaccessparc(Request $request, Response $response)
    {
        try{
            $rows = $request->getParameters();
            $this->perfacessparcService->deletePerfaccessparc($rows);
        }catch(\Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
