<?php

namespace ACL\Services;

use ACL\Helpers\Instances\InstanceProvider;
use ACL\Repositories\Organizacao as OrganizacaoRepository;
use Exception;

class Organizacao {

    /**
     * @var \Teknisa\Libs\Util\Environment
     */
    private $libEnvironment;

    /**
     * @var OrganizacaoRepository
     */
    private $organizacaoRepository;

    /**
     * Organizacao constructor.
     * @param OrganizacaoRepository $organizacaoRepository
     * @throws Exception
     */
    public function __construct(OrganizacaoRepository $organizacaoRepository)
    {
        $this->organizacaoRepository = $organizacaoRepository;
        $this->libEnvironment =  InstanceProvider::getLibEnvironment();
    }

    /**
     * @return array
     */
    public function findOrganizacao(): array
    {
        return $this->organizacaoRepository->findOrganizacao(getNrorg());
    }
}
