/* Tabela PRODUTO: Cadastro de Produtos */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes nas colunas: SGUNIDADE,
            VRPESOUNID, CDPRODESTO, VRFATOCONV, VRARREDCMP, CDTPCTPAGAR, CDPRODORIG, CDTPINDICE, IDPERVALOR,
            CDINDICE, IDPRODATIVPR, NMFANTPROD, IDPRODATIVPR da tabela PRODUTO */
/* Objetivo: Gerar um log que vai registrar na tabela Geral de Logs de Operaes as alteraes nos campos da tabela Produto listados  seguir:
            SGUNIDADE-Sigla da unidade' de medida,
            VRPESOUNID-Peso (em kg) da unidade do produto,
            CDPRODESTO-Cdigo do produto de estoque,
            VRFATOCONV-Fator de converso do produto na unidade do produto de estoque,
            VRARREDCMP-Valor de arredondamento para compras do produto,
            CDTPCTPAGAR-Cdigo do Tipo de Conta a Pagar,
            CDPRODORIG-Cdigo do produto de origem,
            CDTPINDICE-Cdigo do tipo de ndice financeiro (dirio ou mensal),
            IDPERVALOR-Indicador de percentual ou valor,
            CDINDICE-Cdigo do ndice financeiro,
            IDPRODATIVPR-Identificador de produto ativo,
            NMFANTPROD-Nome Codificado do produto
            IDTEOROBRIG - Identificador de produto que obriga teor na anlise (controle de qualidade).
            IDVDANALISE - Identificador de como deve ser gerada a validade da anlise (mes ou formula)
            DSFORMULAVDANA - Descrio da frmula da anlise
            DSFORMULAVDRANA - Descrio da frmula da reanlise*/

CREATE OR REPLACE TRIGGER LOG_SUP_PRODUTO
AFTER DELETE OR INSERT OR UPDATE OF SGUNIDADE,
                                    VRPESOUNID,
                                    CDPRODESTO,
                                    VRFATOCONV,
                                    VRARREDCMP,
                                    CDTPCTPAGAR,
                                    CDPRODORIG,
                                    CDTPINDICE,
                                    IDPERVALOR,
                                    CDINDICE,
                                    IDPRODATIVPR,
                                    NMPRODUTO,
                                    /*Novos campos*/
                                    CDCTBLENTRPR,
                                    CDCTBLSAIDPR,
                                    CDCTBLPRODPR,
                                    CDCTBLCPROPR,
                                    CDCTBLPRACPR,
                                    IDPRCMPATIVO,
                                    NMFANTPROD,
                                    IDTEOROBRIG,
                                    IDVDANALISE,
                                    DSFORMULAVDANA,
                                    DSFORMULAVDRANA,
                                    IDPRODPERIG,
                                    DSINFADICPROD

ON PRODUTO  FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(4000);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF DELETING THEN
      V_IDTIPOOPER   := '3';
      V_ITPESQ       := :OLD.CDARVPROD;
      V_DESC         := 'Produto '       || '' || NVL(:OLD.CDARVPROD,'')||' '||
                        'Cd. Produto '  || '' || NVL(:OLD.CDPRODUTO,'')||' '||
                        'NmCod '         || '' || NVL(:OLD.NMFANTPROD, '');
   ELSE
      IF UPDATING THEN
         V_DESC   := 'Nome '          || '' || NVL(:NEW.NMPRODUTO, '')    ||' '||
                     'Unidade '       || '' || NVL(:NEW.SGUNIDADE,'')     ||' '||
                     'PesoUnid '      || '' || NVL(:NEW.VRPESOUNID,'')    ||' '||
                     'ProdEst '       || '' || NVL(:NEW.CDPRODESTO,'')    ||' '||
                     'FatorConv '     || '' || NVL(:NEW.VRFATOCONV,'')    ||' '||
                     'ArreCmp '       || '' || NVL(:NEW.VRARREDCMP,'')    ||' '||
                     'TpCtbPag '      || '' || NVL(:NEW.CDTPCTPAGAR,'')   ||' '||
                     'ProgOrig '      || '' || NVL(:NEW.CDPRODORIG,'')    ||' '||
                     'CdTPIndice '    || '' || NVL(:NEW.CDTPINDICE,'')    ||' '||
                     'IdIndice '      || '' || NVL(:NEW.IDPERVALOR, '')   ||' '||
                     'CdIndice '      || '' || NVL(:NEW.CDINDICE, '')     ||' '||
                     'ProdAtiv '      || '' || NVL(:NEW.IDPRODATIVPR, '') ||' '||
                     'CtblEntrada='       || :NEW.CDCTBLENTRPR          ||' '||
                     'CtblSaida='         || :NEW.CDCTBLSAIDPR          ||' '||
                     'CtblCustoProd='     || :NEW.CDCTBLPRODPR          ||' '||
                     'CtblContraProva='   || :NEW.CDCTBLCPROPR          ||' '||
                     'Emb. CMP:'          || :NEW.IDPRCMPATIVO          ||' '||
                     'CtblCMV='           || :NEW.CDCTBLPRACPR          ||' '||
                     'NmCod='             || :NEW.NMFANTPROD            ||' '||
                     'IdTeorObrig= '     || '' || :NEW.IDTEOROBRIG       ||' '||
                     'IdVdAanalise= '    || '' || :NEW.IDVDANALISE       ||' '||
                     'DsFormulaVdAna= '  || '' || :NEW.DSFORMULAVDANA    ||' '||
                     'DsFormulaVdRana= ' || '' || :NEW.DSFORMULAVDRANA   ||' '||
                     'IdProdPerig= '     || '' || :NEW.IDPRODPERIG       ||' '||
                     'DsInfAdicProd= '   || '' || :NEW.DSINFADICPROD;
         V_ITPESQ := :NEW.CDPRODUTO;
         V_IDTIPOOPER := '2';
      ELSE
         V_IDTIPOOPER   := '1';
         V_ITPESQ       := :NEW.CDARVPROD;
         V_DESC         := 'Produto '       || '' || NVL(:NEW.CDARVPROD,'') ||' '||
                           'Cd. Produto '  || '' || NVL(:NEW.CDPRODUTO,'') ||' '||
                           'NmCod'          || '' || NVL(:NEW.NMFANTPROD, '');
      END IF;
   END IF;

   V_DESC := SUBSTR(V_DESC, 1, 400);

   IF NOT V_IDTIPOOPER IS NULL THEN
      IF NOT V_DESC IS NULL THEN
         INSERT INTO LOGOPERA
            (NMTABELA,   DTOPERACAO,   NMRESPOPER,   IDTIPOOPER,   DSOPERACAO,
             CDPESQITEM, DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,  DSMETUSUOPER,
             CDORESPOPER)
         VALUES
            ('PRODUTO', SYSDATE, NVL(V_NMOPERADOR,' '), V_IDTIPOOPER, V_DESC, V_ITPESQ,
             V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_SUP_PRODUTO','6.10.xxx'); END;
/

